%%% liczby-cut.pl

%%% Prosty program ilustruący ideę generacji/wyszukiwania rozwiązań w Prologu
%%% oraz efektu zastosowania operatora odcięcia '!'.

% Fakty: definicja dostepnych cyfr. 
   cyfra(0).
   cyfra(1).
   cyfra(2).
   cyfra(3).
   cyfra(4).
   cyfra(5).   
   cyfra(6).
   cyfra(7).
   cyfra(8).
   cyfra(9).

% Przykładowa definicja liczby trzycyfrowej
   liczba(X):-
      cyfra(S),
      cyfra(D),
      cyfra(J),!,
      X is 100*S+10*D+J.

liczba(_):- write('koniec'), nl.

% Przykład wypisywania liczb od 0 do 999.
   write999 :-
      liczba(X),
      write(X),nl,
      fail.
   write999 :-
      write('=====').

% Przykład wypisywania liczb z zadanego zakresu od A do Z
% Uwaga: przykład ma charakter logiczny; uzyta metoda nie jest efektywna
   writeAZ(A,Z) :-
      liczba(X),
      X >= A,
      X =< Z,
      write(X), nl,
      fail.
   writeAZ(_,_) :-
      write('=====').

% Modyfikacje:
% 1. Zmiana zakresu.
% 2. Zmiana kolejności.
% 3. Zmiana sposobu wypisywania.

% eof

